﻿@page "/teamSeasons"
@using Models.TeamData
@using Business.Repository.IRepository
@inject ITeamSeasonRepository TeamSeasonRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Registration</h4>
    </div>
    <div class="col-3 offset-1">
        <NavLink href="teamSeasons/create" class="btn btn-primary form-control">Register New Team</NavLink>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th width="5%" class="text-center">#</th>
                    <th width="30%" class="text-center">Team</th>
                    <th width="30%" class="text-center">Season</th>
                    <th width="10%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (TeamSeasons.Any())
                {
                    int i = 1;
                    @foreach (var teamSeason in TeamSeasons)
                    {
                        <tr>
                            <td class="text-center">@i</td>
                            @{i++;}
                            <td class="text-center">@teamSeason.Team.Name</td>
                            <td class="text-center">@teamSeason.Season.Name</td>
                            <td>
                                <NavLink href="@($"teamSeasons/teamPlayers/{teamSeason.Id}")" class="btn btn-primary">Players</NavLink>
                                <button class="btn btn-danger" @onclick="() => HandleDelete(teamSeason.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    private IEnumerable<TeamSeasonDTO> TeamSeasons { get; set; } = new List<TeamSeasonDTO>();
    private int? DeleteTeamSeasonId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;

    protected async override Task OnInitializedAsync()
    {
        TeamSeasons = await TeamSeasonRepository.GetAllFromSeason(await localStorage.GetItemAsync<int>("seasonId"));
    }

    private async Task HandleDelete(int teamSeasonId)
    {
        DeleteTeamSeasonId = teamSeasonId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteTeamSeasonId != null)
        {
            await TeamSeasonRepository.Delete(DeleteTeamSeasonId.Value);
            await JsRuntime.ToastrSuccess("TeamSeason deleted successfully!");
            TeamSeasons = await TeamSeasonRepository.GetAllFromSeason(await localStorage.GetItemAsync<int>("seasonId"));
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
}